#include <stdio.h> 
#include <stdlib.h> 

#define CHARLIST "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz" 
#define CHARLEN 62 

int from62table[128] = {
                           0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
                           0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
                           0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
                           0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 0, 0, 0, 0, 0, 0,
                           0, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24,
                           25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 0, 0, 0, 0, 0,
                           0, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50,
                           51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 0, 0, 0, 0, 0
                       };

char *to62(int num)
{
    char *dst;
    char *p;
    char tmp;
    int len;
    int i;

    dst = malloc(6 + 1); /* 62^6 = 0xD398ED040 */
    if(!dst) {
        exit(1);
    }

    p = dst;
    while(num)
    {
        *p++ = CHARLIST[num % CHARLEN];
        num /= CHARLEN;
    }

    len = strlen(dst);
    for(i = 0; i < len/2; i++)
    {
        tmp = dst[i];
        dst[i] = dst[len - i - 1];
        dst[len - i - 1] = tmp;
    }

    return dst;
}

int from62(char *numstr) {
    int num = 0;

    while(*numstr)
    {
        num *= CHARLEN;
        num += from62table[*numstr & 0x7f];
        numstr++;
    }

    return num;
}

int main(int argc, char *argv[])
{

    if(argc != 2) {
        fprintf(stderr, "usgae: %s 123\n\n", argv[0]);
        exit(0);
    }

    printf("%s\n", to62(atoi(argv[1])));
    printf("%d\n", from62(to62(atoi(argv[1]))));
    exit(0);
}
